"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeYoutubeIframe = _interopRequireDefault(require("react-native-youtube-iframe"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const ImageCarousel = ({
  images = [],
  videos = [],
  height,
  width,
  activeDotColor = '#333333',
  inactiveDotColor = '#BCBCBC',
  resizeMode = 'cover',
  carouselTiming = 1000
}) => {
  const [currentPage, setCurrentPage] = (0, _react.useState)(0);
  const scrollViewRef = (0, _react.useRef)(null);
  const {
    width: screenWidth
  } = _reactNative.Dimensions.get('window');
  const media = [...images, ...videos]; // Combine images and videos

  (0, _react.useEffect)(() => {
    const interval = setInterval(() => {
      if (scrollViewRef.current) {
        const nextPageIndex = (currentPage + 1) % media.length;
        scrollViewRef.current.scrollTo({
          x: nextPageIndex * screenWidth,
          animated: true
        });
      }
    }, carouselTiming);
    return () => clearInterval(interval);
  }, [currentPage, media.length, screenWidth, carouselTiming]);
  const handleScroll = event => {
    const {
      contentOffset
    } = event.nativeEvent;
    const currentPageIndex = Math.round(contentOffset.x / screenWidth);
    setCurrentPage(currentPageIndex);
  };
  const scrollToPage = pageIndex => {
    if (scrollViewRef.current) {
      scrollViewRef.current.scrollTo({
        x: pageIndex * screenWidth,
        animated: true
      });
      setCurrentPage(pageIndex);
    }
  };
  const isYouTubeVideo = item => {
    return videos.includes(item);
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.container, {
      height,
      width
    }]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.ScrollView, {
    ref: scrollViewRef,
    horizontal: true,
    pagingEnabled: true,
    showsHorizontalScrollIndicator: false,
    onScroll: handleScroll,
    scrollEventThrottle: 16
  }, media.map((item, index) => /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    key: index,
    style: {
      height,
      width
    }
  }, isYouTubeVideo(item) ? /*#__PURE__*/_react.default.createElement(_reactNativeYoutubeIframe.default, {
    height: height,
    width: width,
    videoId: item
  }) : /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: typeof item === 'string' ? {
      uri: item
    } : item,
    style: {
      height,
      width
    },
    resizeMode: resizeMode
  })))), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.pagination
  }, media.map((_, index) => /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    key: index,
    style: [styles.paginationDot, {
      backgroundColor: currentPage === index ? activeDotColor : inactiveDotColor
    }],
    onTouchStart: () => scrollToPage(index)
  }))));
};
const styles = _reactNative.StyleSheet.create({
  container: {
    alignItems: 'stretch',
    justifyContent: 'center'
  },
  pagination: {
    flexDirection: 'row',
    justifyContent: 'center',
    alignItems: 'center'
  },
  paginationDot: {
    width: 8,
    height: 8,
    borderRadius: 4,
    marginHorizontal: 5,
    marginTop: 10
  }
});
var _default = exports.default = ImageCarousel;
//# sourceMappingURL=index.js.map